/*****************************************************************************
**  This is part of the CTSim program
**  Copyright (C) 1983-2000 Kevin Rosenberg
**
**  $Id: keyboard.h,v 1.2 2000/04/28 14:14:16 kevin Exp $
**  $Log: keyboard.h,v $
**  Revision 1.2  2000/04/28 14:14:16  kevin
**  *** empty log message ***
**
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License (version 2) as
**  published by the Free Software Foundation.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************/
/******************************************************************************
 *
 * FILE IDENTIFICATION
 *
 *	File Name:	KEYBOARD.H
 *	Author:		Kevin Rosenberg
 *	Purpose:	Header file for IBM-PC keyboard definitions
 *	Date Started:	Jan 85
 *
 * DESCRIPTION
 *
 * MODIFICATION LOG
 *
 *****************************************************************************/

#ifndef KEYBOARD_H
#define KEYBOARD_H

#define KEY_BKSP	 8
#define KEY_TAB		 9
#define KEY_RETURN	13
#define KEY_ESCAPE	27

#define KEY_HOME	0x4700
#define KEY_UP		0x4800
#define KEY_PGUP	0x4900
#define KEY_LEFT	0x4B00
#define KEY_CENTER	0x4C00		/* center of numeric keypad = 5 */
#define KEY_RIGHT	0x4D00
#define KEY_END		0x4F00
#define KEY_DOWN	0x5000
#define KEY_PGDOWN	0x5100

#define KEY_F1		0x3B00
#define KEY_F2		0x3C00
#define KEY_F3		0x3D00
#define KEY_F4		0x3E00
#define KEY_F5		0x3F00
#define KEY_F6		0x4000
#define KEY_F7		0x4100
#define KEY_F8		0x4200
#define KEY_F9		0x4300
#define KEY_F10		0x4400

#define KEY_SHIFTF1	0x5400
#define KEY_SHIFTF2	0x5500
#define KEY_SHIFTF3	0x5600
#define KEY_SHIFTF4	0x5700
#define KEY_SHIFTF5	0x5800
#define KEY_SHIFTF6	0x5900
#define KEY_SHIFTF7	0x5A00
#define KEY_SHIFTF8	0x5B00
#define KEY_SHIFTF9	0x5C00
#define KEY_SHIFTF10	0x5D00

#define KEY_CTRLF1	0x5E00
#define KEY_CTRLF2	0x5F00
#define KEY_CTRLF3	0x6000
#define KEY_CTRLF4	0x6100
#define KEY_CTRLF5	0x6200
#define KEY_CTRLF6	0x6300
#define KEY_CTRLF7	0x6400
#define KEY_CTRLF8	0x6500
#define KEY_CTRLF9	0x6600
#define KEY_CTRLF10	0x6700

#define KEY_ALTF1	0x6800
#define KEY_ALTF2	0x6900
#define KEY_ALTF3	0x6A00
#define KEY_ALTF4	0x6B00
#define KEY_ALTF5	0x6C00
#define KEY_ALTF6	0x6D00
#define KEY_ALTF7	0x6E00
#define KEY_ALTF8	0x6F00
#define KEY_ALTF9	0x7000
#define KEY_ALTF10	0x7100


#endif	/* #ifndef KEYBOARD_H */
